<%
/*
 * IBM Confidential OCO Source Material
 *
 * Licensed Materials - Property of IBM
 * 5724-Y62 WebSphere Sensor Events
 * (c) Copyright IBM Corp. 2003, 2009  All rights reserved.
 *
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U. S. Copyright Office.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"%>

<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<fmt:setBundle basename="com.ibm.rfid.resources.Messages"/>

<HTML lang="<fmt:message key="language"/>" dir="<fmt:message key="direction"/>">
<HEAD>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<LINK REL="stylesheet" HREF="/ibmrfidadmin/theme/Master.css" TYPE="text/css">
<TITLE><fmt:message key="admin.console"/></TITLE>
</HEAD>
<%@ page errorPage="../misc/apperror.jsp?debug=log" %>
<% request.setAttribute("sourcePage", request.getRequestURI()); %>
<%@ page import = "com.ibm.rfid.admin.utilities.AdminConstants"%>
<%@ page import = "com.ibm.rfid.actionform.admin.DCLocation"%>
<%@ page import = "com.ibm.rfid.main.sysmgmt.ejb.sdo.DeviceSDO" %>
<%@ page import = "com.ibm.rfid.main.ejb.session.dto.ObjectClassDTO" %>
<%@ page import = "java.util.Collection"%>
<%@ page import = "java.util.ArrayList"%>
<%@ page import = "java.util.Arrays" %>
<%@ page import = "java.util.Map"%>
<%@ page import = "java.util.Iterator"%>
<%@ page import = "java.util.HashMap" %>
<%@ page import = "java.util.TreeMap" %>
<%@ page import = "com.ibm.rfid.main.ejb.session.dto.CategoryMetaDataDTO"%>
<%@ include file = "../misc/utils.jsp"%>

<!-- when doc loads, set the focus to the value field -->
<BODY onLoad="document.forms.locationAddForm.locId.focus()">

<!-- include some js utils -->
<SCRIPT LANGUAGE="javascript" SRC="/ibmrfidadmin/web/misc/utils.js"></SCRIPT>
<SCRIPT language="JavaScript">

function changeLocationGroup() {
	url = "/ibmrfidadmin/secure/dcLocation.sl?" ;
	url = url + "locationAction=Update Contained Location";
	url = url + "&locId=" + document.getElementById("id").value;
	url = url + "&userName=" + document.getElementById("name").value;
	url = url + "&locAlias=" + document.getElementById("alias").value;
	url = url + "&desc=" + document.getElementById("description").value;
	url = url + "&isAddressable=" + document.getElementById("addressable").options[document.getElementById("addressable").selectedIndex].value;
	url = url + "&isInSelfTestMode=" + document.getElementById("SelfTestMode").options[document.getElementById("SelfTestMode").selectedIndex].value;	
	url = url + "&readerId=" + document.getElementById("readerIds").options[document.getElementById("readerIds").selectedIndex].value;	
	url = url + "&deviceId=" + document.getElementById("deviceIds").options[document.getElementById("deviceIds").selectedIndex].value;	
	url = url + "&parentLoc=" + document.getElementById("parentLocation").value;	
	url = url + "&locationType=" + document.getElementById("locationType").options[document.getElementById("locationType").selectedIndex].value;	
	url = url + "&addressStreet1=" + document.getElementById("street1").value;
	url = url + "&addressStreet2=" + document.getElementById("street2").value;
	url = url + "&addressCity=" + document.getElementById("city").value;
	url = url + "&addressState=" + document.getElementById("state").value;
	url = url + "&addressZip=" + document.getElementById("zip").value;
	url = url + "&timeStamp=" + (new Date()).getTime();
	window.location = url;	
}

function createHiddenFields() {
	// no fields required
}

function validateForm() {
	if (!validateNameNotEmpty(document.locationAddForm.locId.value, '<fmt:message key="location.id.field.cannot.be.empty"/>')) {
		document.locationAddForm.locId.focus();
		return false;
	}

	if (!validateNameNotEmpty(document.locationAddForm.locAlias.value, '<fmt:message key="location.alias.field.cannot.be.empty"/>')) {
		document.locationAddForm.locAlias.focus();
		return false;
	}
		
	if (!hasValidCharsOnly(document.locationAddForm.locId.value, '1234567890')) {
		alert("<fmt:message key="location.id.must.only.contain"/>");
		document.locationAddForm.locId.focus();
		return false;
	}
	
	return true;
}
</SCRIPT>
	<%
	Map locationUserNames = (Map) session.getAttribute(AdminConstants.LOCATION_USER_NAME);
	DCLocation location = (DCLocation) session.getAttribute(AdminConstants.LOCATION);
	ArrayList devices = (ArrayList) session.getAttribute(AdminConstants.AVAILABLE_DEVICES);
	ArrayList readers = (ArrayList) session.getAttribute(AdminConstants.AVAILABLE_READERS);	//148473
	ArrayList locationTypes = (ArrayList) session.getAttribute(AdminConstants.LOCATION_TYPE);
	String pName = location.getParentLoc();

	Collection contacts = location.getContactAll();
	String contactList = "";
   	if (contacts != null && contacts.size() > 0) {
		Iterator itr = contacts.iterator();
	    while (itr.hasNext()) {
	    	String contact = (String) itr.next();
	    	if ( contact != null && contact.equalsIgnoreCase(location.getContactName())){
	    		contactList += "<OPTION SELECTED>" + contact + "</OPTION>";
	    	} else {
				contactList += "<OPTION>" + contact + "</OPTION>";
			}
	    }   
   }   
  	// 148473
	String readerList = "<OPTION value=\"\"></OPTION>";	
	String selectedLocationReaderId = (String) session.getAttribute("selectedLocationReaderId");
	if (readers != null && readers.size() > 0) {
		DeviceSDO deviceSDO = null;
		String readerId = null;
		String readerName = null;
		for (Iterator r=readers.iterator(); r.hasNext(); ) {
			deviceSDO = (DeviceSDO) r.next();
			readerId = deviceSDO.getId();
			readerName = deviceSDO.getUserName();
			if (selectedLocationReaderId != null && selectedLocationReaderId.equalsIgnoreCase(readerId)) {
				readerList += "<OPTION selected value=\"" + readerId + "\">" + readerName + "</OPTION>";
			} else {
				readerList += "<OPTION value=\"" + readerId + "\">" + readerName + "</OPTION>";
			}
		}
	}
	
	String deviceList = "<OPTION value=\"\"></OPTION>";
	String selectedLocationDeviceId = (String) session.getAttribute("selectedLocationDeviceId");
	if (devices != null && devices.size() > 0) {
		DeviceSDO deviceSDO = null;
		String deviceId = null;
		String deviceName = null;	
		for (Iterator d=devices.iterator(); d.hasNext(); ) {
			deviceSDO = (DeviceSDO) d.next();
			deviceId = deviceSDO.getId();
			deviceName = deviceSDO.getUserName();			
			if (selectedLocationDeviceId != null && selectedLocationDeviceId.equalsIgnoreCase(deviceId)) {
				deviceList += "<OPTION selected value=\"" + deviceId + "\">" + deviceName + "</OPTION>";
			} else {
				deviceList += "<OPTION value=\"" + deviceId + "\">" + deviceName + "</OPTION>";
			}
		}
	}

	String locationTypeList = "<OPTION value=\"\"></OPTION>";
	String currentLocationType = location.getLocationType();
	if (currentLocationType == null) {
		currentLocationType = "";
	}
	if (locationTypes != null && locationTypes.size() > 0) {
		ObjectClassDTO locationTypeDTO = null;
		String locationTypeName = null;	
		for (Iterator d=locationTypes.iterator(); d.hasNext(); ) {
			locationTypeDTO = (ObjectClassDTO) d.next();
			locationTypeName = locationTypeDTO.getObjectclassname();
			if (locationTypeName != null && locationTypeName.equals(currentLocationType)) {
				locationTypeList += "<OPTION selected value=\"" + locationTypeName + "\">" + locationTypeName + "</OPTION>";
			} else {
				locationTypeList += "<OPTION value=\"" + locationTypeName + "\">" + locationTypeName + "</OPTION>";
			}
		}
	}		
%>

<H1><fmt:message key="create.new.location"/></H1>

<P class="instructions"><fmt:message key="to.create.a.new.location"/></P>

    <FORM name="locationAddForm" action="/ibmrfidadmin/secure/dcLocation.sl">
    <TABLE>
    	<CAPTION><fmt:message key="add.new.location.table"/></CAPTION>
	    <TR>
	    	<TH nowrap scope="row"><LABEL for="id"><fmt:message key="location.id"/></LABEL></TH>
	    	<TD><INPUT type="text" name="locId" id="id" value="<%=location.getLocId() == null ? "" : location.getLocId()%>" size="65" maxlength="10"></TD>
	    </TR>
	    <TR>
	    	<TH nowrap scope="row"><LABEL for="name"><fmt:message key="location.name"/></LABEL></TH>
	    	<TD><INPUT type="text" name="userName" id="name" value="<%=location.getUserName() == null ? "" : location.getUserName()%>" size="65" maxLength="250"></TD>
	    </TR>
	    <TR>
	    	<TH nowrap scope="row"><LABEL for="alias"><fmt:message key="location.alias"/></LABEL></TH>
	    	<TD><INPUT type="text" name="locAlias" id="alias" value="<%=location.getLocAlias() == null ? "" : location.getLocAlias()%>" size="65"></TD>
	    </TR>
	    <TR>
			<TH nowrap scope="row"><LABEL for="description"><fmt:message key="description"/></LABEL></TH>
			<TD><INPUT type="text" name="desc" id="description" value="<%=location.getDesc() == null ? "" : location.getDesc()%>" size="65"></TD>
		</TR>
	    <TR>
			<TH nowrap scope="row"><LABEL for="addressable"><fmt:message key="is.addressable"/></LABEL></TH>			
			<TD><SELECT name="isAddressable" id="addressable" style="WIDTH: 425px">
					<% String addressable= location.getIsAddressable(); %>
					<OPTION <% if( addressable != null && addressable.equalsIgnoreCase("false")){%> SELECTED <%}%> value="false"><fmt:message key="false"/></OPTION>
					<OPTION <% if( addressable != null && addressable.equalsIgnoreCase("true")){%> SELECTED <%}%>value="true"><fmt:message key="true"/></OPTION>
				</SELECT>
			</TD>			
		</TR>
		<%-- feature 138675 --%>
	    <TR>
			<TH nowrap scope="row"><LABEL for="SelfTestMode"><fmt:message key="is.inselftestmode"/></LABEL></TH>			
			<TD><SELECT name="isInSelfTestMode" id="SelfTestMode" style="WIDTH: 425px">
					<% String selftestmode= location.getIsInSelfTestMode(); %>
					<OPTION <% if( selftestmode != null && selftestmode.equalsIgnoreCase("false")){%> SELECTED <%}%> value="false"><fmt:message key="false"/></OPTION>
					<OPTION <% if( selftestmode != null && selftestmode.equalsIgnoreCase("true")){%> SELECTED <%}%> value="true"><fmt:message key="true"/></OPTION>
				</SELECT>
			</TD>			
		</TR>
		<%-- feature 138675 --%>
	    <TR>
			<TH nowrap scope="row"><LABEL for="contact"><fmt:message key="contact"/></LABEL></TH>			
			<TD>
			   <SELECT name="contactName" id="contact" style="WIDTH: 425px">
			       <%=contactList%>
			   </SELECT>
			</TD>
		</TR>
		<TR>
			<TH  nowrap scope="row"><fmt:message key="container.location"/></TH>
		<%	if (pName == null || pName.equals("")) {
				%><TD><INPUT type="text" name="parentLoc" id="parentLocation" style="background-color: #CCCCCC" size="65" value="<fmt:message key="root.location"/>"></TD><%
			} else {
				%><TD><INPUT type="text" name="parentLoc" id="parentLocation" style="background-color: #CCCCCC" size="65" value="<%=location.getParentLoc()%>"></TD><%
			} %>
		</TR>
		<TR>
		<TH nowrap scope="row"><LABEL for="readerIds"><fmt:message key="reader"/></LABEL></TH>	
		<TD>
		   <SELECT name="readerIds" id="readerIds" style="WIDTH: 425px">
		       <%=readerList%>
		   </SELECT>
		 </TD>
		 </TR>
		 
		<TR>
		<TH nowrap scope="row"><LABEL for="deviceIds"><fmt:message key="device"/></LABEL></TH>	
		<TD>
		   <SELECT name="deviceIds" id="deviceIds" style="WIDTH: 425px">
		       <%=deviceList%>
		   </SELECT>
		 </TD>
		 </TR>

		<TR>
		<TH nowrap scope="row"><LABEL for="locationType"><fmt:message key="location.type"/></LABEL></TH>	
		<TD>
		   <SELECT name="locationType" id="locationType" style="WIDTH: 425px" onChange="changeLocationGroup();">
		       <%=locationTypeList%>
		   </SELECT>
		</TD>
		</TR>
		<!-- if user has the proper role, display the proper buttons -->
	<%	ArrayList props =(ArrayList) session.getAttribute("metadata");
 		if (props != null && props.size() > 0) { 
			// put the props into other collections for easier access
			Map propMapName = new HashMap();
			CategoryMetaDataDTO catDTO = null;
			for (Iterator i=props.iterator(); i.hasNext(); ) {
				catDTO = (CategoryMetaDataDTO) i.next();
				propMapName.put(catDTO.getAttributename(), catDTO);
			}
		
			Map propMapDescr = new TreeMap();			
			for (Iterator i=propMapName.values().iterator(); i.hasNext(); ) {
				catDTO = (CategoryMetaDataDTO) i.next();
				
				// set sorted by description (use name if description
				// is null)
				String key = catDTO.getAttributedescription();
				if (key == null) {
					key = catDTO.getAttributename();
				}
				propMapDescr.put(key, catDTO);
			}
			
			String name = null;
			String description = null;
			String value = null;
				
			for (Iterator i=propMapDescr.values().iterator(); i.hasNext(); ) {
				catDTO = (CategoryMetaDataDTO) i.next();

				name = DCLocation.LOCATION_METADATA_PREFIX + catDTO.getAttributename();
				
				description = catDTO.getAttributedescription();
				if (description == null) {
					description = catDTO.getAttributename();
				}
				
				value = catDTO.getAttributevalue();	
				if (value == null) {
					value = "";
				}
				
				if (value.indexOf(AdminConstants.MULTI_ATTR_VALUE_DELIMITER) < 0) {
					// value is for one value; generate an input field
		%>
			<TR>
				<TH scope="row"><LABEL for="<%=name%>"><%=description%></LABEL>
				<INPUT type="hidden" name="<%="description."+name%>" id="<%="description."+name%>" value="<%=description%>">
				</TH>
   				<TD><INPUT type="text" name="<%=name.replaceAll("\\.","_dot_")%>" id="<%=name%>" value="<%=value%>" size="65" maxlength="250"></TD>   			
 			</TR>			
		<%
				} else {
					// value is for multiple values; generate a list
					String[] options = value.split(AdminConstants.MULTI_ATTR_VALUE_DELIMITER);
					if (options != null && options.length > 0) {
		%>
			<TR>
				<TH scope="row"><LABEL for="<%=name%>"><%=description%></LABEL>
				<INPUT type="hidden" name="<%="description."+name.replaceAll("\\.","_dot_")%>" id="<%="description."+name%>" value="<%=description%>">
				</TH>
				<TD>
					<SELECT size="1" name="<%=name.replaceAll("\\.","_dot_")%>" id="<%=name%>" style="width:100%">
		<%
						for (int j=0; j<options.length; j++) {
							if( options[j].startsWith("[") && options[j].endsWith("]") ){
								String defaultValue=options[j].substring(1,options[j].length()-1);
		%>
							<OPTION SELECTED value="<%=defaultValue%>"><%=defaultValue%></OPTION>
		<%								
							} else {		
		%>
							<OPTION value="<%=options[j]%>"><%=options[j]%></OPTION>
		<%
							}
						}
		%>
					</SELECT>
				</TD>
			</TR>
	<%
					}					
				}
			}
		}
 	%> 	  
	  </TABLE>

	<H2><fmt:message key="address"/></H2>
		<TABLE>
			<CAPTION><fmt:message key="new.location.address.table"/></CAPTION>
			<TBODY>
	    	<TR>
				<TH width="100" scope="row"><LABEL for="street1"><fmt:message key="street"/></LABEL></TH>
					<TD><INPUT type="text" id="street1" name="addressStreet1" value="" size="65"></TD>
			</TR>
	    	<TR>
				<TH scope="row"><LABEL for="street2"><fmt:message key="street"/></LABEL></TH>
					<TD><INPUT type="text" id="street2" name="addressStreet2" value="" size="65"></TD>
			</TR>
		    <TR>
				<TH scope="row"><LABEL for="city"><fmt:message key="city"/></LABEL></TH>
					<TD><INPUT type="text" id="city" name="addressCity" value="" size="65"></TD>
			</TR>
		    <TR>
				<TH scope="row"><LABEL for="state"><fmt:message key="state"/></LABEL></TH>
					<TD><INPUT type="text" id="state" name="addressState" value="" size="65"></TD>
			</TR>
		    <TR>
				<TH scope="row"><LABEL for="zip"><fmt:message key="zip"/></LABEL></TH>
					<TD><INPUT type="text" id="zip" name="addressZip" value="" size="65"></TD>
			</TR>			
			</TBODY>		
		</TABLE>
<BR><BR>
		<INPUT type="hidden" name="parentLoc" value="<%=location.getParentLoc()%>">
		<INPUT type="submit" name="locationAction" value="<fmt:message key="create"/>" onClick="createHiddenFields();return validateForm();">
		<INPUT type="reset"  name="resetAction" value="<fmt:message key="reset"/>">
		<INPUT type="submit" name="locationAction" value="<fmt:message key="cancel"/>">
	</FORM>
</BODY>
</HTML>

